<HTML>
<BODY BGCOLOR="white">
<PRE>
<FONT color="green">001</FONT>    /*<a name="line.1"></a>
<FONT color="green">002</FONT>     * =============================================================================<a name="line.2"></a>
<FONT color="green">003</FONT>     * Simplified BSD License, see http://www.opensource.org/licenses/<a name="line.3"></a>
<FONT color="green">004</FONT>     * -----------------------------------------------------------------------------<a name="line.4"></a>
<FONT color="green">005</FONT>     * Copyright (c) 2008-2009, Marco Terzer, Zurich, Switzerland<a name="line.5"></a>
<FONT color="green">006</FONT>     * All rights reserved.<a name="line.6"></a>
<FONT color="green">007</FONT>     * <a name="line.7"></a>
<FONT color="green">008</FONT>     * Redistribution and use in source and binary forms, with or without <a name="line.8"></a>
<FONT color="green">009</FONT>     * modification, are permitted provided that the following conditions are met:<a name="line.9"></a>
<FONT color="green">010</FONT>     * <a name="line.10"></a>
<FONT color="green">011</FONT>     *     * Redistributions of source code must retain the above copyright notice, <a name="line.11"></a>
<FONT color="green">012</FONT>     *       this list of conditions and the following disclaimer.<a name="line.12"></a>
<FONT color="green">013</FONT>     *     * Redistributions in binary form must reproduce the above copyright <a name="line.13"></a>
<FONT color="green">014</FONT>     *       notice, this list of conditions and the following disclaimer in the <a name="line.14"></a>
<FONT color="green">015</FONT>     *       documentation and/or other materials provided with the distribution.<a name="line.15"></a>
<FONT color="green">016</FONT>     *     * Neither the name of the Swiss Federal Institute of Technology Zurich <a name="line.16"></a>
<FONT color="green">017</FONT>     *       nor the names of its contributors may be used to endorse or promote <a name="line.17"></a>
<FONT color="green">018</FONT>     *       products derived from this software without specific prior written <a name="line.18"></a>
<FONT color="green">019</FONT>     *       permission.<a name="line.19"></a>
<FONT color="green">020</FONT>     * <a name="line.20"></a>
<FONT color="green">021</FONT>     * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" <a name="line.21"></a>
<FONT color="green">022</FONT>     * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE <a name="line.22"></a>
<FONT color="green">023</FONT>     * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE <a name="line.23"></a>
<FONT color="green">024</FONT>     * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE <a name="line.24"></a>
<FONT color="green">025</FONT>     * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR <a name="line.25"></a>
<FONT color="green">026</FONT>     * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF <a name="line.26"></a>
<FONT color="green">027</FONT>     * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS <a name="line.27"></a>
<FONT color="green">028</FONT>     * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN <a name="line.28"></a>
<FONT color="green">029</FONT>     * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) <a name="line.29"></a>
<FONT color="green">030</FONT>     * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE <a name="line.30"></a>
<FONT color="green">031</FONT>     * POSSIBILITY OF SUCH DAMAGE.<a name="line.31"></a>
<FONT color="green">032</FONT>     * =============================================================================<a name="line.32"></a>
<FONT color="green">033</FONT>     */<a name="line.33"></a>
<FONT color="green">034</FONT>    package ch.javasoft.math.ops;<a name="line.34"></a>
<FONT color="green">035</FONT>    <a name="line.35"></a>
<FONT color="green">036</FONT>    import java.io.DataInput;<a name="line.36"></a>
<FONT color="green">037</FONT>    import java.io.DataOutput;<a name="line.37"></a>
<FONT color="green">038</FONT>    import java.io.IOException;<a name="line.38"></a>
<FONT color="green">039</FONT>    import java.math.BigDecimal;<a name="line.39"></a>
<FONT color="green">040</FONT>    import java.math.BigInteger;<a name="line.40"></a>
<FONT color="green">041</FONT>    import java.math.MathContext;<a name="line.41"></a>
<FONT color="green">042</FONT>    import java.math.RoundingMode;<a name="line.42"></a>
<FONT color="green">043</FONT>    <a name="line.43"></a>
<FONT color="green">044</FONT>    import ch.javasoft.math.BigFraction;<a name="line.44"></a>
<FONT color="green">045</FONT>    import ch.javasoft.math.NumberOperations;<a name="line.45"></a>
<FONT color="green">046</FONT>    <a name="line.46"></a>
<FONT color="green">047</FONT>    /**<a name="line.47"></a>
<FONT color="green">048</FONT>     * {@link NumberOperations Number operations} for {@link BigDecimal} numbers.<a name="line.48"></a>
<FONT color="green">049</FONT>     * The instantiation of a {@code BigDecimalOperations} requires a <a name="line.49"></a>
<FONT color="green">050</FONT>     * {@link MathContext} which defines rounding.<a name="line.50"></a>
<FONT color="green">051</FONT>     */<a name="line.51"></a>
<FONT color="green">052</FONT>    public class BigDecimalOperations extends AbstractNumberOps&lt;BigDecimal&gt; {<a name="line.52"></a>
<FONT color="green">053</FONT>            <a name="line.53"></a>
<FONT color="green">054</FONT>            private final MathContext mathContext;<a name="line.54"></a>
<FONT color="green">055</FONT>            <a name="line.55"></a>
<FONT color="green">056</FONT>            /**<a name="line.56"></a>
<FONT color="green">057</FONT>             * Constructor for &lt;code&gt;BigDecimalOperations&lt;/code&gt; with specified math<a name="line.57"></a>
<FONT color="green">058</FONT>             * context defining rounding<a name="line.58"></a>
<FONT color="green">059</FONT>             */<a name="line.59"></a>
<FONT color="green">060</FONT>            public BigDecimalOperations(MathContext mathContext) { <a name="line.60"></a>
<FONT color="green">061</FONT>                    this.mathContext = mathContext;<a name="line.61"></a>
<FONT color="green">062</FONT>            }<a name="line.62"></a>
<FONT color="green">063</FONT>        /**<a name="line.63"></a>
<FONT color="green">064</FONT>         * Constructs a new {@code BigDecimalOperations} with the specified<a name="line.64"></a>
<FONT color="green">065</FONT>         * precision and the {@link RoundingMode#HALF_UP HALF_UP} rounding<a name="line.65"></a>
<FONT color="green">066</FONT>         * mode.<a name="line.66"></a>
<FONT color="green">067</FONT>         *<a name="line.67"></a>
<FONT color="green">068</FONT>         * @param setPrecision The non-negative {@code int} precision setting.<a name="line.68"></a>
<FONT color="green">069</FONT>         * @throws IllegalArgumentException if the {@code setPrecision} parameter is <a name="line.69"></a>
<FONT color="green">070</FONT>         *                  less than zero.<a name="line.70"></a>
<FONT color="green">071</FONT>         */<a name="line.71"></a>
<FONT color="green">072</FONT>        public BigDecimalOperations(int setPrecision) {<a name="line.72"></a>
<FONT color="green">073</FONT>            this(new MathContext(setPrecision));<a name="line.73"></a>
<FONT color="green">074</FONT>        }<a name="line.74"></a>
<FONT color="green">075</FONT>        /**<a name="line.75"></a>
<FONT color="green">076</FONT>         * Constructs a new {@code BigDecimalOperations} with {@code MathContext} <a name="line.76"></a>
<FONT color="green">077</FONT>         * from a string.<a name="line.77"></a>
<FONT color="green">078</FONT>         *<a name="line.78"></a>
<FONT color="green">079</FONT>         * The string must be in the same format as that produced by the<a name="line.79"></a>
<FONT color="green">080</FONT>         * {@link MathContext#toString} method.<a name="line.80"></a>
<FONT color="green">081</FONT>         * <a name="line.81"></a>
<FONT color="green">082</FONT>         * &lt;p&gt;An {@code IllegalArgumentException} is thrown if the precision<a name="line.82"></a>
<FONT color="green">083</FONT>         * section of the string is out of range ({@code &lt; 0}) or the string is<a name="line.83"></a>
<FONT color="green">084</FONT>         * not in the format created by the {@link #toString} method.<a name="line.84"></a>
<FONT color="green">085</FONT>         *<a name="line.85"></a>
<FONT color="green">086</FONT>         * @param contextVal The string to be parsed<a name="line.86"></a>
<FONT color="green">087</FONT>         * @throws IllegalArgumentException if the precision section is out of range<a name="line.87"></a>
<FONT color="green">088</FONT>         * or of incorrect format<a name="line.88"></a>
<FONT color="green">089</FONT>         * @throws NullPointerException if the argument is {@code null}<a name="line.89"></a>
<FONT color="green">090</FONT>         */<a name="line.90"></a>
<FONT color="green">091</FONT>        public BigDecimalOperations(String contextVal) {<a name="line.91"></a>
<FONT color="green">092</FONT>            this(new MathContext(contextVal));<a name="line.92"></a>
<FONT color="green">093</FONT>        }<a name="line.93"></a>
<FONT color="green">094</FONT>            <a name="line.94"></a>
<FONT color="green">095</FONT>            /**<a name="line.95"></a>
<FONT color="green">096</FONT>             * Returns the math context defined when instantiating this <a name="line.96"></a>
<FONT color="green">097</FONT>             * {@code BigDecimalOperations}<a name="line.97"></a>
<FONT color="green">098</FONT>             */<a name="line.98"></a>
<FONT color="green">099</FONT>            public MathContext getMathContext() {<a name="line.99"></a>
<FONT color="green">100</FONT>                    return mathContext;<a name="line.100"></a>
<FONT color="green">101</FONT>            }<a name="line.101"></a>
<FONT color="green">102</FONT>            <a name="line.102"></a>
<FONT color="green">103</FONT>            public Class&lt;BigDecimal&gt; numberClass() {<a name="line.103"></a>
<FONT color="green">104</FONT>                    return BigDecimal.class;<a name="line.104"></a>
<FONT color="green">105</FONT>            }<a name="line.105"></a>
<FONT color="green">106</FONT>            public BigDecimal[] newArray(int size) {<a name="line.106"></a>
<FONT color="green">107</FONT>                    return new BigDecimal[size];<a name="line.107"></a>
<FONT color="green">108</FONT>            }<a name="line.108"></a>
<FONT color="green">109</FONT>            public BigDecimal[][] newArray(int rows, int cols) {<a name="line.109"></a>
<FONT color="green">110</FONT>                    return new BigDecimal[rows][cols];<a name="line.110"></a>
<FONT color="green">111</FONT>            }<a name="line.111"></a>
<FONT color="green">112</FONT>            public BigDecimal valueOf(String s) {<a name="line.112"></a>
<FONT color="green">113</FONT>                    return new BigDecimal(s);<a name="line.113"></a>
<FONT color="green">114</FONT>            }<a name="line.114"></a>
<FONT color="green">115</FONT>            public BigDecimal valueOf(Number number) {<a name="line.115"></a>
<FONT color="green">116</FONT>                    if (number instanceof BigDecimal) {<a name="line.116"></a>
<FONT color="green">117</FONT>                            return (BigDecimal)number;<a name="line.117"></a>
<FONT color="green">118</FONT>                    }<a name="line.118"></a>
<FONT color="green">119</FONT>                    if (number instanceof BigInteger) {<a name="line.119"></a>
<FONT color="green">120</FONT>                            return new BigDecimal((BigInteger)number);<a name="line.120"></a>
<FONT color="green">121</FONT>                    }<a name="line.121"></a>
<FONT color="green">122</FONT>                    if (number instanceof Long || number instanceof Integer || number instanceof Short || number instanceof Byte) {<a name="line.122"></a>
<FONT color="green">123</FONT>                            return BigDecimal.valueOf(number.longValue());<a name="line.123"></a>
<FONT color="green">124</FONT>                    }<a name="line.124"></a>
<FONT color="green">125</FONT>                    if (number instanceof Double || number instanceof Float) {<a name="line.125"></a>
<FONT color="green">126</FONT>                            return BigDecimal.valueOf(number.doubleValue());<a name="line.126"></a>
<FONT color="green">127</FONT>                    }<a name="line.127"></a>
<FONT color="green">128</FONT>                    if (number instanceof BigFraction) {<a name="line.128"></a>
<FONT color="green">129</FONT>                            return ((BigFraction)number).toBigDecimal(mathContext);<a name="line.129"></a>
<FONT color="green">130</FONT>                    }<a name="line.130"></a>
<FONT color="green">131</FONT>                    return valueOf(number.toString());<a name="line.131"></a>
<FONT color="green">132</FONT>            }<a name="line.132"></a>
<FONT color="green">133</FONT>            public BigDecimal valueOf(long value) {<a name="line.133"></a>
<FONT color="green">134</FONT>                    return BigDecimal.valueOf(value);<a name="line.134"></a>
<FONT color="green">135</FONT>            }<a name="line.135"></a>
<FONT color="green">136</FONT>            public BigDecimal valueOf(double value) {<a name="line.136"></a>
<FONT color="green">137</FONT>                    return BigDecimal.valueOf(value);<a name="line.137"></a>
<FONT color="green">138</FONT>            }<a name="line.138"></a>
<FONT color="green">139</FONT>            @Override<a name="line.139"></a>
<FONT color="green">140</FONT>            public BigDecimal abs(BigDecimal number) {<a name="line.140"></a>
<FONT color="green">141</FONT>                    return number.abs(mathContext);<a name="line.141"></a>
<FONT color="green">142</FONT>            }<a name="line.142"></a>
<FONT color="green">143</FONT>            public BigDecimal add(BigDecimal numA, BigDecimal numB) {<a name="line.143"></a>
<FONT color="green">144</FONT>                    return numA.add(numB, mathContext);<a name="line.144"></a>
<FONT color="green">145</FONT>            }<a name="line.145"></a>
<FONT color="green">146</FONT>            public BigDecimal divide(BigDecimal numA, BigDecimal numB) {<a name="line.146"></a>
<FONT color="green">147</FONT>                    return numA.divide(numB, mathContext);<a name="line.147"></a>
<FONT color="green">148</FONT>            }<a name="line.148"></a>
<FONT color="green">149</FONT>            @Override<a name="line.149"></a>
<FONT color="green">150</FONT>            public BigDecimal invert(BigDecimal number) {<a name="line.150"></a>
<FONT color="green">151</FONT>                    return divide(BigDecimal.ONE, number);<a name="line.151"></a>
<FONT color="green">152</FONT>            }<a name="line.152"></a>
<FONT color="green">153</FONT>            @Override<a name="line.153"></a>
<FONT color="green">154</FONT>            public boolean isOne(BigDecimal number) {<a name="line.154"></a>
<FONT color="green">155</FONT>                    return BigDecimal.ONE.equals(number);<a name="line.155"></a>
<FONT color="green">156</FONT>            }<a name="line.156"></a>
<FONT color="green">157</FONT>            public BigDecimal multiply(BigDecimal numA, BigDecimal numB) {<a name="line.157"></a>
<FONT color="green">158</FONT>                    return numA.multiply(numB, mathContext);<a name="line.158"></a>
<FONT color="green">159</FONT>            }<a name="line.159"></a>
<FONT color="green">160</FONT>            public BigDecimal negate(BigDecimal number) {<a name="line.160"></a>
<FONT color="green">161</FONT>                    return number.negate(mathContext);<a name="line.161"></a>
<FONT color="green">162</FONT>            }<a name="line.162"></a>
<FONT color="green">163</FONT>            public BigDecimal one() {<a name="line.163"></a>
<FONT color="green">164</FONT>                    return BigDecimal.ONE;<a name="line.164"></a>
<FONT color="green">165</FONT>            }<a name="line.165"></a>
<FONT color="green">166</FONT>            public BigDecimal subtract(BigDecimal numA, BigDecimal numB) {<a name="line.166"></a>
<FONT color="green">167</FONT>                    return numA.subtract(numB, mathContext);<a name="line.167"></a>
<FONT color="green">168</FONT>            }<a name="line.168"></a>
<FONT color="green">169</FONT>            public BigDecimal zero() {<a name="line.169"></a>
<FONT color="green">170</FONT>                    return BigDecimal.ZERO;<a name="line.170"></a>
<FONT color="green">171</FONT>            }<a name="line.171"></a>
<FONT color="green">172</FONT>            public int compare(BigDecimal o1, BigDecimal o2) {<a name="line.172"></a>
<FONT color="green">173</FONT>                    return o1.compareTo(o2);<a name="line.173"></a>
<FONT color="green">174</FONT>            }<a name="line.174"></a>
<FONT color="green">175</FONT>            /**<a name="line.175"></a>
<FONT color="green">176</FONT>             * Returns the rounded number according to the current <a name="line.176"></a>
<FONT color="green">177</FONT>             * {@link #getMathContext() math context}, that is, <a name="line.177"></a>
<FONT color="green">178</FONT>             * {@link BigDecimal#round(MathContext)} is called<a name="line.178"></a>
<FONT color="green">179</FONT>             */<a name="line.179"></a>
<FONT color="green">180</FONT>            public BigDecimal reduce(BigDecimal number) {<a name="line.180"></a>
<FONT color="green">181</FONT>                    return number.round(mathContext);<a name="line.181"></a>
<FONT color="green">182</FONT>            }<a name="line.182"></a>
<FONT color="green">183</FONT>            /**<a name="line.183"></a>
<FONT color="green">184</FONT>             * Returns the unchanged vector<a name="line.184"></a>
<FONT color="green">185</FONT>             */<a name="line.185"></a>
<FONT color="green">186</FONT>            public BigDecimal[] reduceVector(boolean cloneOnChange, BigDecimal... vector) {<a name="line.186"></a>
<FONT color="green">187</FONT>                    return vector;<a name="line.187"></a>
<FONT color="green">188</FONT>            }<a name="line.188"></a>
<FONT color="green">189</FONT>            public int signum(BigDecimal number) {<a name="line.189"></a>
<FONT color="green">190</FONT>                    return number.signum();<a name="line.190"></a>
<FONT color="green">191</FONT>            }<a name="line.191"></a>
<FONT color="green">192</FONT>            public BigDecimal pow(BigDecimal numA, BigDecimal numB) {<a name="line.192"></a>
<FONT color="green">193</FONT>                    final int expSign = numB.signum();<a name="line.193"></a>
<FONT color="green">194</FONT>                    if (expSign == 0) return BigDecimal.ONE;<a name="line.194"></a>
<FONT color="green">195</FONT>                    if (isOne(numA)) return BigDecimal.ONE;<a name="line.195"></a>
<FONT color="green">196</FONT>                    try {<a name="line.196"></a>
<FONT color="green">197</FONT>                            final BigInteger inumB = numB.toBigIntegerExact();<a name="line.197"></a>
<FONT color="green">198</FONT>                            if (expSign &gt; 0 &amp;&amp; inumB.compareTo(BigInteger.valueOf(Integer.MAX_VALUE)) &gt; 0) {<a name="line.198"></a>
<FONT color="green">199</FONT>                                    throw new ArithmeticException(<a name="line.199"></a>
<FONT color="green">200</FONT>                                            "exponent too large, only integer range supported: " + <a name="line.200"></a>
<FONT color="green">201</FONT>                                            inumB + " &gt; " + Integer.MAX_VALUE<a name="line.201"></a>
<FONT color="green">202</FONT>                                    );                                      <a name="line.202"></a>
<FONT color="green">203</FONT>                            }<a name="line.203"></a>
<FONT color="green">204</FONT>                            if (expSign &lt; 0 &amp;&amp; inumB.compareTo(BigInteger.valueOf(Integer.MIN_VALUE + 1)) &lt; 0) {<a name="line.204"></a>
<FONT color="green">205</FONT>                                    throw new ArithmeticException(<a name="line.205"></a>
<FONT color="green">206</FONT>                                            "exponent too small, only integer range supported: " + <a name="line.206"></a>
<FONT color="green">207</FONT>                                            inumB + " &lt; " + Integer.MIN_VALUE<a name="line.207"></a>
<FONT color="green">208</FONT>                                    );                                      <a name="line.208"></a>
<FONT color="green">209</FONT>                            }<a name="line.209"></a>
<FONT color="green">210</FONT>                            return numA.pow(inumB.intValue());<a name="line.210"></a>
<FONT color="green">211</FONT>                    }<a name="line.211"></a>
<FONT color="green">212</FONT>                    catch (ArithmeticException e) {<a name="line.212"></a>
<FONT color="green">213</FONT>                            throw new ArithmeticException("non-integer exponent not supported");<a name="line.213"></a>
<FONT color="green">214</FONT>                    }<a name="line.214"></a>
<FONT color="green">215</FONT>            }<a name="line.215"></a>
<FONT color="green">216</FONT>            public byte[] toByteArray(BigDecimal number) {<a name="line.216"></a>
<FONT color="green">217</FONT>                    final int scale = number.scale();<a name="line.217"></a>
<FONT color="green">218</FONT>                    final BigInteger unscaled = number.unscaledValue();<a name="line.218"></a>
<FONT color="green">219</FONT>                    final byte[] value = unscaled.toByteArray();<a name="line.219"></a>
<FONT color="green">220</FONT>                    final byte[] bytes = new byte[value.length + 4];<a name="line.220"></a>
<FONT color="green">221</FONT>            bytes[0] = (byte)(scale &gt;&gt;&gt; 24);<a name="line.221"></a>
<FONT color="green">222</FONT>            bytes[1] = (byte)(scale &gt;&gt;&gt; 16);<a name="line.222"></a>
<FONT color="green">223</FONT>            bytes[2] = (byte)(scale &gt;&gt;&gt;  8);<a name="line.223"></a>
<FONT color="green">224</FONT>            bytes[3] = (byte)(scale &gt;&gt;&gt;  0);<a name="line.224"></a>
<FONT color="green">225</FONT>            System.arraycopy(value, 0, bytes, 4, value.length);<a name="line.225"></a>
<FONT color="green">226</FONT>            return bytes;<a name="line.226"></a>
<FONT color="green">227</FONT>            }<a name="line.227"></a>
<FONT color="green">228</FONT>            public void writeTo(BigDecimal number, DataOutput out) throws IOException {<a name="line.228"></a>
<FONT color="green">229</FONT>                    final byte[] bytes = number.unscaledValue().toByteArray();<a name="line.229"></a>
<FONT color="green">230</FONT>                    out.writeInt(number.scale());<a name="line.230"></a>
<FONT color="green">231</FONT>                    out.writeInt(bytes.length);<a name="line.231"></a>
<FONT color="green">232</FONT>                    out.write(bytes);<a name="line.232"></a>
<FONT color="green">233</FONT>            }<a name="line.233"></a>
<FONT color="green">234</FONT>            /**<a name="line.234"></a>
<FONT color="green">235</FONT>             * {@inheritDoc}<a name="line.235"></a>
<FONT color="green">236</FONT>             * <a name="line.236"></a>
<FONT color="green">237</FONT>             * &lt;p&gt;<a name="line.237"></a>
<FONT color="green">238</FONT>             * Returns the value as stored, without applying rounding according to the<a name="line.238"></a>
<FONT color="green">239</FONT>             * {@link #getMathContext() math context}.<a name="line.239"></a>
<FONT color="green">240</FONT>             */<a name="line.240"></a>
<FONT color="green">241</FONT>            @SuppressWarnings("cast")<a name="line.241"></a>
<FONT color="green">242</FONT>        public BigDecimal fromByteArray(byte[] bytes) {<a name="line.242"></a>
<FONT color="green">243</FONT>                    final int scale =<a name="line.243"></a>
<FONT color="green">244</FONT>                (((int)bytes[0]) &lt;&lt; 24) +<a name="line.244"></a>
<FONT color="green">245</FONT>                (((int)bytes[1]) &lt;&lt; 16) +<a name="line.245"></a>
<FONT color="green">246</FONT>                (((int)bytes[2]) &lt;&lt;  8) +<a name="line.246"></a>
<FONT color="green">247</FONT>                (((int)bytes[3]) &lt;&lt;  0);                                      <a name="line.247"></a>
<FONT color="green">248</FONT>                    final byte[] vals = new byte[bytes.length - 4];<a name="line.248"></a>
<FONT color="green">249</FONT>                    System.arraycopy(bytes, 4, vals, 0, vals.length);<a name="line.249"></a>
<FONT color="green">250</FONT>                    final BigInteger unscaled = new BigInteger(bytes);<a name="line.250"></a>
<FONT color="green">251</FONT>            return new BigDecimal(unscaled, scale);<a name="line.251"></a>
<FONT color="green">252</FONT>            }<a name="line.252"></a>
<FONT color="green">253</FONT>            /**<a name="line.253"></a>
<FONT color="green">254</FONT>             * {@inheritDoc}<a name="line.254"></a>
<FONT color="green">255</FONT>             * <a name="line.255"></a>
<FONT color="green">256</FONT>             * &lt;p&gt;<a name="line.256"></a>
<FONT color="green">257</FONT>             * Returns the value as stored, without applying rounding according to the<a name="line.257"></a>
<FONT color="green">258</FONT>             * {@link #getMathContext() math context}.<a name="line.258"></a>
<FONT color="green">259</FONT>             */<a name="line.259"></a>
<FONT color="green">260</FONT>            public BigDecimal readFrom(DataInput in) throws IOException {<a name="line.260"></a>
<FONT color="green">261</FONT>                    final int scale         = in.readInt();<a name="line.261"></a>
<FONT color="green">262</FONT>                    final int length        = in.readInt();<a name="line.262"></a>
<FONT color="green">263</FONT>                    final byte[] value = new byte[length];<a name="line.263"></a>
<FONT color="green">264</FONT>                    in.readFully(value);<a name="line.264"></a>
<FONT color="green">265</FONT>                    final BigInteger unscaled = new BigInteger(value);<a name="line.265"></a>
<FONT color="green">266</FONT>                    return new BigDecimal(unscaled, scale);<a name="line.266"></a>
<FONT color="green">267</FONT>            }<a name="line.267"></a>
<FONT color="green">268</FONT>            public int byteLength() {<a name="line.268"></a>
<FONT color="green">269</FONT>                    return -1;<a name="line.269"></a>
<FONT color="green">270</FONT>            }<a name="line.270"></a>
<FONT color="green">271</FONT>    }<a name="line.271"></a>




























































</PRE>
</BODY>
</HTML>
